#include <os.h>
#include <fdlibm.h>
#include "nRayC.h"

#define R5G6B5(r,g,b) ((r << 11) | (g << 5) | b)

int main(void)
{
	ScreenPoint pixel;
	int r, g, b, color;
	int palette[256];
	char *buffer1, *buffer2;
	
	buffer1 = malloc(SCREEN_BYTES_SIZE);
	if(!buffer1) exit(0);
	
	buffer2 = malloc(320*240);
	if(!buffer2)
	{
		free(buffer1);
		exit(0);
	}
	
	for(pixel.x = 0; pixel.x < 256; pixel.x++)
	{
		r = (int)(sin(M_PI * pixel.x / 32.0) * 16 + 16);
		g = (int)(sin(M_PI * pixel.x / 64.0) * 32 + 32);
		b = (int)(sin(M_PI * pixel.x / 128.0) * 16 + 16);
		palette[pixel.x] = R5G6B5(r,g,b);
	}
	
	for(pixel.y = 0; pixel.y < 240; pixel.y++)
	{
		for(pixel.x = 0; pixel.x < 320; pixel.x++)
		{
			color = (int)(
						128.0 + (128.0 * sin(pixel.x / 16.0))
					+	128.0 + (128.0 * sin(pixel.y / 8.0))
					+	128.0 + (128.0 * sin(sqrt((pixel.x - 160) * (pixel.x - 160) + (pixel.y - 120) * (pixel.y - 120)) / 16.0))
					+	128.0 + (128.0 * sin(sqrt(pixel.x * pixel.y) / 8.0))
					) / 4;
			buffer2[pixel.y * 320 + pixel.x] = color;
		}
	}
	
	while(!isKeyPressed(KEY_NSPIRE_ESC))
	{
		for(pixel.y = 0; pixel.y < 240; pixel.y++)
		{
			for(pixel.x = 0; pixel.x < 320; pixel.x++)
			{
				nRC_setPixel(pixel, palette[buffer2[pixel.y * 320 + pixel.x]], buffer1);
			}
		}
		nRC_dispBuf(buffer1);
		nRC_clearBuf(buffer1);
		
		for(pixel.y = 0; pixel.y < 5; pixel.y++)
		{
			color = palette[0];
			for(pixel.x = 0; pixel.x < 255; pixel.x++) palette[pixel.x] = palette[pixel.x+1];
			palette[255] = color;
		}
	}
	
	free(buffer1);
	free(buffer2);
	return 0;
}
